/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "spi.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "ssd1331_spi_lib.h"
#include "font1.h"
#include "font2.h"
#include "logo565.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */
void Opcja_Info(void);
void Opcja_Kolory(void);
void Opcja_Rysunek(void);
void Opcja_Przewin(void);
void Opcja_Przyciemnij(void);
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  signed char pozycja=1;
  signed char aktualizacja=0; //0 - rysuj cale menu, -1 - nie rysuj menu (aktualizacja niepotrzebna), >0 - aktualizacja pozycji o podanym numerze
  unsigned char i=0;
  const char *menu[6] = {"Info\0", "Paleta kolor\x8E""w\0", "Rysunek\0", "Przewijanie\0", "Przyciemnienie\0"}; //podwojny "" w celu polaczenia ciagow znakowych, zeby kompilator wiedzial gdzie koczy sie kod hex

  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  SSD1331_SPI_HwConfig();
  SSD1331_SPI_Init();

  while (1)
  {

    if (aktualizacja>=0){                                     //rysowanie menu tylko po powrocie z opcji menu lub na poczatku programu
      if (aktualizacja==0) {
    	SSD1331_ClearScreen();
    	SSD1331_FillRect(  0, 0, 95, 18, RGB565(128,128,128), RGB565(128,128,128));
    	SSD1331_WriteTextXY("MENU\0",32,0,RGB565(255,255,255),RGB565(128,128,128), font2);
      }
      for (i=1;i<=5;i++){                                    //rysowanie napisow menu
        if ((i==aktualizacja)||(aktualizacja==0)) {          //tylko pozycja wybrana poprzedni (lub wszystkie jesli odswiezanie calego menu)
          SSD1331_FillRect(  0, i*10+3, 95, i*10+3+10, RGB565(0,150,0),RGB565(0,150,0));
          SSD1331_WriteTextXY(menu[i-1], 5, i*10+5, RGB565(255,255,255),RGB565(0,150,0), font1);
        }
        if (i==pozycja) {                                    //aktualnie wybrana pozycja
          SSD1331_FillRect(  0, i*10+3, 95, i*10+3+10, RGB565(0,70,0),RGB565(0,70,0));
          SSD1331_WriteTextXY(menu[i-1], 5, i*10+5, RGB565(255,255,255),RGB565(0,70,0), font1);
        }
      }
      aktualizacja=-1;
    }


    if (!HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_0) && (pozycja>1)){  //joystick gora
      aktualizacja=pozycja;
      pozycja--;
    }

    if (!HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_1) && (pozycja<5)){  //joystick dol
      aktualizacja=pozycja;
      pozycja++;
    }

    if (!HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_5)){                 //wybor opcji z menu
      switch (pozycja){
        case 1: Opcja_Info();     break;
        case 2: Opcja_Kolory();   break;
        case 3: Opcja_Rysunek();  break;
        case 4: Opcja_Przewin();  break;
        case 5: Opcja_Przyciemnij(); break;
      }
      aktualizacja=0;
    }

	HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_8);
	HAL_Delay(200);

	/* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

void Opcja_Info(void){
  SSD1331_FillRect(0, 0, 95, 63, RGB565(0,0,175), RGB565(0,0,175));
  SSD1331_WriteTextXY("   DEMO   \0", 7,  3, RGB565(255,255,255), RGB565(0,0,175), font2);
  SSD1331_WriteTextXY(" wy\x8Fwietlacza\0", 6, 19, RGB565(255,255,255), RGB565(0,0,175), font1);
  SSD1331_WriteTextXY("   Waveshare    \0", 3, 30, RGB565(255,255,255), RGB565(0,0,175), font1);
  SSD1331_WriteTextXY(" RGB OLED 0.95\"\0", 3, 41, RGB565(255,255,255), RGB565(0,0,175), font1);
  SSD1331_WriteTextXY("   (SSD1331)    \0", 3, 52, RGB565(255,255,255), RGB565(0,0,175), font1);
  HAL_Delay(5000);
}


void Opcja_Kolory(void) {
  int r,g,b,i;
  unsigned char x,y;

  SSD1331_ClearScreen();

  //paleta 4096 kolorow
  x=0;
  y=0;
  for (r=0;r<=0xF;r++){
    for (g=0;g<=0xF;g++){
	  for (b=0;b<=0xF;b++){
	    SSD1331_DrawPixel(x,y,RGB565(r<<3,g<<3,b<<3));
	    x=x+1;
	    if (x>95) {
		  x=0;
		  y=y+1;
	    }
	  }
    }
  }

  //przejscia tonalne
  for (i=0;i<=0x3F;i++){
    SSD1331_DrawLine(16+i, 50, 16+i,  51, RGB565(i<<2, 0   , 0   ));
    SSD1331_DrawLine(16+i, 52, 16+i,  53, RGB565(0   , i<<2, 0   ));
    SSD1331_DrawLine(16+i, 54, 16+i,  55, RGB565(0   , 0   , i<<2));
    SSD1331_DrawLine(16+i, 56, 16+i,  57, RGB565(i<<2, i<<2, i<<2));
  }

  //kolory podstawowe
  SSD1331_FillRect( 0, 44, 12, 53, RGB565(255,  0,  0), RGB565(255,  0,  0));
  SSD1331_FillRect( 0, 54, 12, 63, RGB565(  0,255,  0), RGB565(  0,255,  0));
  SSD1331_FillRect(83, 44, 95, 53, RGB565(  0,  0,255), RGB565(  0,  0,255));
  SSD1331_FillRect(83, 54, 95, 63, RGB565(255,255,255), RGB565(255,255,255));
  HAL_Delay(5000);
}


void Opcja_Rysunek(void){
  SSD1331_ClearScreen();
  SSD1331_WriteTextXY("STM32F103",12,1,RGB565(200,200,200),RGB565(10,10,10),font2);
  SSD1331_DrawLine(10, 16, 86, 16, RGB565(70,70,155));
  SSD1331_Write565Bitmap(logo,2,20,40,38);
  SSD1331_DrawPixel( 0, 0,RGB565(255,0,0));
  SSD1331_DrawPixel( 0,63,RGB565(255,0,0));
  SSD1331_DrawPixel(95, 0,RGB565(255,0,0));
  SSD1331_DrawPixel(95,63,RGB565(255,0,0));
  SSD1331_FillRect(60, 30, 90, 60, RGB565(50,0,0), RGB565(50,50,50));
  SSD1331_DrawCircle(75, 45, 14, RGB565(100,0,0));
  SSD1331_FillCircle(75, 45,  7, RGB565(100,0,50));
  SSD1331_DrawPixel(75,45,RGB565(255,0,0));

  HAL_Delay(5000);
}


void Opcja_Przewin(void){
  SSD1331_SPI_WriteByte(SSD1331_CONTINUOUS_SCROLLING_SETUP, SSD1331_CMD);
  SSD1331_SPI_WriteByte(0, SSD1331_CMD);  //bez przewijania w poziomie
  SSD1331_SPI_WriteByte(0, SSD1331_CMD);  //poczatkowy wiersz przewijania w pionie
  SSD1331_SPI_WriteByte(64,SSD1331_CMD);  //koncowy wiersz przewijania w pionie
  SSD1331_SPI_WriteByte(1, SSD1331_CMD);  //po jednej linii
  SSD1331_SPI_WriteByte(0, SSD1331_CMD);  //co 6 klatek
  SSD1331_SPI_WriteByte(SSD1331_ACTIVE_SCROLLING, SSD1331_CMD);
  HAL_Delay(4036);                       //2 pelne przewiniecia ekranu
  SSD1331_SPI_WriteByte(SSD1331_DEACTIVE_SCROLLING, SSD1331_CMD);
}


void Opcja_Przyciemnij(void){
  SSD1331_SPI_WriteByte(SSD1331_DISPLAY_ON_DIM, SSD1331_CMD);
  HAL_Delay(5000);
  SSD1331_SPI_WriteByte(SSD1331_DISPLAY_ON_NORMAL, SSD1331_CMD);
}

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
