/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "spi.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "st7735s_spi_lib.h"
#include "font1.h"
#include "font2.h"
#include "logo565.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */
void Opcja_Info(void);
void Opcja_Kolory(void);
void Opcja_Rysunek(void);
void Opcja_Przewin(void);
void Opcja_Obroty(void);
void Opcja_Negatyw(void);
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  signed char pozycja=1;
  signed char aktualizacja=0; //0 - rysuj cale menu, -1 - nie rysuj menu (aktualizacja niepotrzebna), >0 - aktualizacja pozycji o podanym numerze
  unsigned char i=0;
  const char *menu[7] = {"Info\0", "Paleta kolor\x8E""w\0", "Rysunek\0", "Przewijanie\0", "Obr\x8E""t\0", "Negatyw\0"}; //podwojny "" w celu polaczenia ciagow znakowych, zeby kompilator wiedzial gdzie koczy sie kod hex
  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  ST7735_SPI_HwConfig();
  ST7735_SPI_Init();

  while (1)
  {

    if (aktualizacja>=0){                                     //rysowanie menu tylko po powrocie z opcji menu lub na poczatku programu
      if (aktualizacja==0) {
    	ST7735_ClearScreen(RGB(0,0,0));
    	ST7735_FillRect(  0, 0, 127, 16, RGB(128,128,128));
    	ST7735_WriteTextXY("MENU\0",48,1,RGB(255,255,255),RGB(128,128,128), font2);
      }
      for (i=1;i<=6;i++){                                    //rysowanie napisow menu
        if ((i==aktualizacja)||(aktualizacja==0)) {          //tylko pozycja wybrana poprzedni (lub wszystkie jesli odswiezanie calego menu)
          ST7735_FillRect(  0, i*12+5, 127, i*12+5+11, RGB(0,150,0));
          ST7735_WriteTextXY(menu[i-1], 5, i*12+7, RGB(255,255,255),RGB(0,150,0), font1);
        }
        if (i==pozycja) {                                    //aktualnie wybrana pozycja
          ST7735_FillRect(  0, i*12+5, 127, i*12+5+11, RGB(0,70,0));
          ST7735_WriteTextXY(menu[i-1], 5, i*12+7, RGB(255,255,255),RGB(0,70,0), font1);
        }
      }
      aktualizacja=-1;
    }


    if (!HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_0) && (pozycja>1)){  //joystick gora
      aktualizacja=pozycja;
      pozycja--;
    }

    if (!HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_1) && (pozycja<6)){  //joystick dol
      aktualizacja=pozycja;
      pozycja++;
    }

    if (!HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_5)){                 //wybor opcji z menu
      switch (pozycja){
        case 1: Opcja_Info();     break;
        case 2: Opcja_Kolory();   break;
        case 3: Opcja_Rysunek();  break;
        case 4: Opcja_Przewin();  break;
        case 5: Opcja_Obroty();    break;
        case 6: Opcja_Negatyw();  break;
      }
      aktualizacja=0;
    }


	HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_8);
	HAL_Delay(200);

    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

void Opcja_Info(void){
  ST7735_ClearScreen(RGB(0,0,175));
  ST7735_WriteTextXY("   DEMO   \0", 23,  23, RGB(255,255,255), RGB(0,0,175), font2);
  ST7735_WriteTextXY(" wy\x8F""wietlacza\0", 22, 40, RGB(255,255,255), RGB(0,0,175), font1);
  ST7735_WriteTextXY("   Waveshare    \0", 19, 52, RGB(255,255,255), RGB(0,0,175), font1);
  ST7735_WriteTextXY(" RGB LCD 1.80\"\0", 22, 64, RGB(255,255,255), RGB(0,0,175), font1);
  ST7735_WriteTextXY("  128x160 px   \0", 22, 76, RGB(255,255,255), RGB(0,0,175), font1);
  ST7735_WriteTextXY("   (ST7735S)    \0", 19, 88, RGB(255,255,255), RGB(0,0,175), font1);
  HAL_Delay(5000);
}


void Opcja_Kolory(void) {
  int r,g,b,i,color,t;

  for (t=5;t<=6;t++){
	ST7735_ClearScreen(RGB(0,0,0));
    ST7735_SPI_WriteByte(ST7735_COLMOD, ST7735_CMD);
	ST7735_SPI_WriteByte(t, ST7735_DATA);                              //przelacz na 16 lub 18 bit
	ST7735settings.ColorMode=t;

	if (t==5) ST7735_WriteTextXY("16 bit  65536 kolor\x8E""w\0", 1, 0, RGB(255,255,255), RGB(0,0,0), font1);
	if (t==6) ST7735_WriteTextXY("18 bit  262144 kolory\0", 1, 0, RGB(255,255,255), RGB(0,0,0), font1);

    //przejscia tonalne
    for (i=0;i<=0x3F;i++){
      ST7735_DrawLine(32+i, 145, 32+i, 148, RGB(i<<2, 0   , 0   ));
      ST7735_DrawLine(32+i, 149, 32+i, 151, RGB(0   , i<<2, 0   ));
      ST7735_DrawLine(32+i, 152, 32+i, 154, RGB(0   , 0   , i<<2));
      ST7735_DrawLine(32+i, 155, 32+i, 157, RGB(i<<2, i<<2, i<<2));
    }

    ST7735_FillRect(  0, 140, 10, 150, RGB(255,  0,  0));
    ST7735_FillRect(  0, 151, 10, 160, RGB(  0,255,  0));
    ST7735_FillRect(118, 140,127, 150, RGB(  0,  0,255));
    ST7735_FillRect(118, 151,127, 160, RGB(255,255,255));

    ST7735_SetWindow(0,0+10,127,127+10); //kwadrat kolorow
    for (r=0;r<=255;r+=4){
      for (g=0;g<=255;g+=2){
	    for (b=0;b<=255;b+=2){
		  if(ST7735settings.ColorMode==ST7735_COLOR_RGB565) color=RGB565(r,g,b);  //convert color to 16bit if 565 mode
	      else color=RGB(r,g,b);

		  if (ST7735settings.ColorMode==ST7735_COLOR_RGB666){
		    ST7735_SPI_WriteByte(color >> 16, ST7735_DATA);       //send 24bit color, high byte
		  }
		  ST7735_SPI_WriteByte(color >> 8, ST7735_DATA);          //send 24bit color middle byte or 16 bit color high byte
		  ST7735_SPI_WriteByte(color, ST7735_DATA);               //low byte
	    }
      }
    }
    HAL_Delay(5000);

	ST7735_ClearScreen(RGB(255,0,0));
	ST7735_WriteTextXY("Red\0", 52, 72, RGB(0,0,0), RGB(255,0,0), font2);
	HAL_Delay(1000);
	ST7735_ClearScreen(RGB(0,255,0));
	ST7735_WriteTextXY("Green\0", 44, 72, RGB(0,0,0), RGB(0,255,0), font2);
	HAL_Delay(1000);
	ST7735_ClearScreen(RGB(0,0,255));
	ST7735_WriteTextXY("Blue\0", 48, 72, RGB(0,0,0), RGB(0,0,255), font2);
	HAL_Delay(1000);
	ST7735_ClearScreen(RGB(127,127,127));
	ST7735_WriteTextXY("Gray\0", 48, 72, RGB(0,0,0), RGB(127,127,127), font2);
	HAL_Delay(1000);
	ST7735_ClearScreen(RGB(255,255,255));
	ST7735_WriteTextXY("White\0", 44, 72, RGB(0,0,0), RGB(255,255,255), font2);
	HAL_Delay(1000);
	ST7735_ClearScreen(RGB(0,0,0));
	ST7735_WriteTextXY("Black\0", 44, 72, RGB(255,255,255), RGB(0,0,0), font2);
	HAL_Delay(1000);
  }

  ST7735_SPI_WriteByte(ST7735_COLMOD, ST7735_CMD);
  ST7735_SPI_WriteByte(0x05, ST7735_DATA);                              //powroc na 16 bit
  ST7735settings.ColorMode=5;
}


void Opcja_Rysunek(void){
  unsigned int i;

  ST7735_ClearScreen(RGB(0,0,0));
  ST7735_WriteTextXY("STM32F103",28,2,RGB(200,200,200),RGB(10,10,10),font2);
  ST7735_DrawLine(10, 18, 117, 18, RGB(70,70,155));
  ST7735_Write565Bitmap(logo,2,30,40,38);
  ST7735_FillRect(80, 30, 110, 60, RGB(50,0,0));
  ST7735_DrawRect(80, 30, 110, 60, RGB(250,0,0));
  ST7735_DrawCircle(95, 45, 14, RGB(100,0,0));
  ST7735_FillCircle(95, 45,  7, RGB(100,0,50));
  ST7735_DrawPixel(95,45,RGB(255,0,0));

  ST7735_DrawPixel(0,0,RGB(250,250,250));
  ST7735_DrawPixel(127,0,RGB(250,0,0));
  ST7735_DrawPixel(127,159,RGB(0,250,0));
  ST7735_DrawPixel(0,159,RGB(0,0,250));

  for (i=10;i>0;i--){
	ST7735_FillRect(31-i*2, 100-i*2, 31+i*2, 100+i*2, RGB(0,(255-i*20),   0));
	ST7735_FillCircle(92, 100, i*2, RGB(0,   0,(255-i*20)));
	ST7735_DrawRect(31-i, 140-i, 31+i, 140+i, RGB(0,(255-i*25),i*25));
	ST7735_DrawLine(92, 149, 72+i*4, 125, RGB((200-i*20),(255-i*20),(255-i*20)));
  }

  HAL_Delay(5000);
}


void Opcja_Przewin(void){
	unsigned char i;

   ST7735_SPI_WriteByte(ST7735_SCRLAR, ST7735_CMD);
   ST7735_SPI_WriteByte(0  , ST7735_DATA); //obszar staly
   ST7735_SPI_WriteByte(18 , ST7735_DATA);
   ST7735_SPI_WriteByte(0  , ST7735_DATA); //obszar przewijany
   ST7735_SPI_WriteByte(141, ST7735_DATA);
   ST7735_SPI_WriteByte(0  , ST7735_DATA); //obszar staly
   ST7735_SPI_WriteByte(1  , ST7735_DATA);
   for (i=18;i<=142+19;i++){
     ST7735_SPI_WriteByte(ST7735_VSCSAD, ST7735_CMD); //jeden krok przewijania
     ST7735_SPI_WriteByte(0  , ST7735_DATA);
     ST7735_SPI_WriteByte(i  , ST7735_DATA);
     HAL_Delay(10);
   }
   HAL_Delay(100);
   ST7735_SPI_WriteByte(ST7735_NORON, ST7735_CMD);  //powrot do normalnego trybu wyswietlania
}


void Opcja_Obroty(void){
  unsigned char i;

  for (i=0;i<4;i++){
	ST7735_ClearScreen(RGB(0,0,0));
    switch (i){
	  case 0:{
		       ST7735_Rotate(L2R_U2D);
		       ST7735_WriteTextXY("L2R-U2D",10,48,RGB(200,200,200),RGB(0,0,0),font2);
		       ST7735_WriteTextXY("0\x92"  ,10,67,RGB(200,200,200),RGB(0,0,0),font2);
	         }break;
	  case 1:{
	           ST7735_Rotate(D2U_L2R);
	           ST7735_WriteTextXY("D2U_L2R",10,48,RGB(200,200,200),RGB(0,0,0),font2);
		       ST7735_WriteTextXY("90\x92"  ,10,67,RGB(200,200,200),RGB(0,0,0),font2);
             }break;
	  case 2:{
	           ST7735_Rotate(R2L_D2U);
	           ST7735_WriteTextXY("R2L_D2U",10,48,RGB(200,200,200),RGB(0,0,0),font2);
		       ST7735_WriteTextXY("180\x92"  ,10,67,RGB(200,200,200),RGB(0,0,0),font2);
             }break;
	  case 3:{
	           ST7735_Rotate(U2D_R2L);
	           ST7735_WriteTextXY("U2D_R2L",10,48,RGB(200,200,200),RGB(0,0,0),font2);
		       ST7735_WriteTextXY("270\x92"  ,10,67,RGB(200,200,200),RGB(0,0,0),font2);
             }break;
	}
    ST7735_DrawLine(10, 64, 84, 64, RGB(255,70,155));
    ST7735_DrawLine(74, 54, 84, 64, RGB(255,70,155));
    ST7735_DrawLine(74, 74, 84, 64, RGB(255,70,155));
    ST7735_DrawPixel(0                     ,0                      ,RGB(250,250,250));
    ST7735_DrawPixel(ST7735settings.Width-1,0                      ,RGB(250,0,0));
    ST7735_DrawPixel(ST7735settings.Width-1,ST7735settings.Height-1,RGB(0,250,0));
    ST7735_DrawPixel(0                     ,ST7735settings.Height-1,RGB(0,0,250));
    HAL_Delay(2000);
  }

  ST7735_Rotate(L2R_U2D);  //powrot do pozycji podstawowej
}


void Opcja_Negatyw(void){
	if (ST7735settings.InversionMode==0){
      ST7735_SPI_WriteByte(ST7735_INVON, ST7735_CMD);  //wlacz inwersje
      ST7735settings.InversionMode=1;
	} else {
      ST7735_SPI_WriteByte(ST7735_INVOFF, ST7735_CMD);  //powrot do normalnego trybu wyswietlania
      ST7735settings.InversionMode=0;
	}
}

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
